'use strict';
module.exports = function generate_minLength(it) {
  var out = ' ';
  var $lvl = it.level,
    $dataLvl = it.dataLevel,
    $schema = it.schema['minLength'],
    $schemaPath = it.schemaPath + '.' + 'minLength',
    $breakOnError = !it.opts.allErrors;
  var $data = 'data' + ($dataLvl || ''),
    $valid = 'valid' + $lvl,
    $errs = 'errs' + $lvl;
  out += 'if ( ';
  if (it.opts.unicode === false) {
    out += ' ' + ($data) + '.length ';
  } else {
    out += ' ucs2length(' + ($data) + ') ';
  }
  out += ' < ' + ($schema) + ') {  ';
  if (!it.compositeRule && $breakOnError) {
    out += ' validate.errors = [ { keyword: \'' + ('minLength') + '\' , dataPath: (dataPath || \'\') + ' + (it.errorPath) + ' , schemaPath: "' + ($schemaPath) + '" , params: { limit: ' + ($schema) + ' } ';
    if (it.opts.messages !== false) {
      out += ' , message: \'should NOT be shorter than ' + ($schema) + ' characters\' ';
    }
    if (it.opts.verbose) {
      out += ' , schema: ' + ($schema) + ' , parentSchema: validate.schema' + (it.schemaPath) + ' , data: ' + ($data) + ' ';
    }
    out += ' }]; return false; ';
  } else {
    out += '  var err =   { keyword: \'' + ('minLength') + '\' , dataPath: (dataPath || \'\') + ' + (it.errorPath) + ' , schemaPath: "' + ($schemaPath) + '" , params: { limit: ' + ($schema) + ' } ';
    if (it.opts.messages !== false) {
      out += ' , message: \'should NOT be shorter than ' + ($schema) + ' characters\' ';
    }
    if (it.opts.verbose) {
      out += ' , schema: ' + ($schema) + ' , parentSchema: validate.schema' + (it.schemaPath) + ' , data: ' + ($data) + ' ';
    }
    out += ' }; if (vErrors === null) vErrors = [err]; else vErrors.push(err); errors++; ';
  }
  out += '} ';
  if ($breakOnError) {
    out += ' else { ';
  }
  return out;
}
